# To help simplify including Elemental in external projects
# TODO: Complain if Qt5 was used

EL_INC = @CMAKE_INSTALL_PREFIX@/include
EL_LIB = @CMAKE_INSTALL_PREFIX@/lib

CC = @CMAKE_C_COMPILER@
CXX = @CMAKE_CXX_COMPILER@
CXX_FLAGS = @CXX_FLAGS@

MATH_LIBS = @MATH_LIBSTRING@

MPI_CXX_COMPILE_FLAGS = @MPI_CXX_COMPILE_FLAGS@
MPI_LINK_FLAGS = @MPI_LINK_FLAGS@
MPI_CXX_INCSTRING = @MPI_CXX_INCSTRING@
MPI_CXX_LIBSTRING = @MPI_CXX_LIBSTRING@

EL_LINK_FLAGS = -L${EL_LIB} ${MPI_LINK_FLAGS}

THREAD_INIT = @CMAKE_THREAD_LIBS_INIT@
PMRRR_LIBS = -lpmrrr ${THREAD_INIT}

# Attempt to add Qt5 support if needed
EL_HAVE_QT5 = @EL_HAVE_QT5@
ifeq (${EL_HAVE_QT5},TRUE)
  EL_COMPILE_FLAGS = ${CXX_FLAGS} -I${EL_INC} ${MPI_CXX_INCSTRING} \
                       @QT5_COMPILESTRING@ @QT5_INCSTRING@ @QT5_DEFSTRING@
  EL_LIBS = -lEl ${PMRRR_LIBS} ${MATH_LIBS} ${MPI_CXX_LIBSTRING} \
              @QT5_LIBSTRING@
else
  EL_COMPILE_FLAGS = ${CXX_FLAGS} -I${EL_INC} ${MPI_CXX_INCSTRING}
  EL_LIBS = -lEl ${PMRRR_LIBS} ${MATH_LIBS} ${MPI_CXX_LIBSTRING}
endif
